if (!String.prototype.repeat) {
  String.prototype.repeat = function(count) {
    'use strict';
    if (this == null) {
      throw new TypeError('can\'t convert ' + this + ' to object');
    }
    var str = '' + this;
    count = +count;
    if (count != count) {
      count = 0;
    }
    if (count < 0) {
      throw new RangeError('repeat count must be non-negative');
    }
    if (count == Infinity) {
      throw new RangeError('repeat count must be less than infinity');
    }
    count = Math.floor(count);
    if (str.length == 0 || count == 0) {
      return '';
    }
    // Ensuring count is a 31-bit integer allows us to heavily optimize the
    // main part. But anyway, most current (August 2014) browsers can't handle
    // strings 1 << 28 chars or longer, so:
    if (str.length * count >= 1 << 28) {
      throw new RangeError('repeat count must not overflow maximum string size');
    }
    var rpt = '';
    for (;;) {
      if ((count & 1) == 1) {
        rpt += str;
      }
      count >>>= 1;
      if (count == 0) {
        break;
      }
      str += str;
    }
    return rpt;
  };
}

function cursorOff() {
    ansiterm.send('ext_mode','clear','cursor');
    console.gotoxy(0,24);
}

/**
 * Return an argument from argv, or an error if it doesnt exit
 *
 * @param key
 * @param error
 */
function getArg(key,error,abort) {
    index = argv.indexOf(key);

    if ((index !== -1) && (! (argv[index+1] === undefined || argv[index+1].match(/^-/)))) {
        return argv[index+1];
    }

    if (abort) {
        log(LOG_ERROR,error);
        exit(1);
    }
}

function getFrame(page) {
	if (! page.index)
		page.index = 'a';

	// @todo Need to filter out SAUCE
	f = new File(system.text_dir+'ansitex/'+pageStr(page)+'.tex');
	if (! f.exists || ! f.open('r')) {
		return null;
	}

	try {
	    frame = JSON.parse(f.read());
	    x = new Frame(0);
	    frame.render = x.render;

	    // @todo Figure out how to delete this duplicate code
        Object.defineProperty(frame,'page', {
            get: function() {return this.frame+this.index}
        });
	} catch (error) {
        log(LOG_ERROR,error);
	    return null;
    }

    log(LOG_ERROR,'Loaded frame: ['+frame.frame+']['+frame.index+'] ('+frame.page+')');
	return frame;
}

/**
 * Return the frame as a string
 */
function pageStr(page) {
    if (! page.index)
        page.index = 'a';

	return page.frame+page.index;
}

function sendBaseline(text,reposition) {
	console.pushxy();
	console.gotoxy(0,24);
	console.print(text);
	console.cleartoeol();

	if (! reposition) {
		console.popxy();
	}
}
